;'use strict';var ManifestHelper=function(manifest){var localeRoot=manifest;var locales=manifest.locales;if(locales){var lang=document.documentElement.lang;localeRoot=locales[lang]||locales[lang.split('-')[0]]||manifest;}
for(var prop in manifest){this[prop]=localeRoot[prop]||manifest[prop];}};;'use strict';var Message=function Message(type,data){this.type=type;this.data=data;};Message.Type={'ADD_BOOKMARK':0};;'use strict';const LandingPage=(function(){var _=navigator.mozL10n.get;var dateTimeFormat=new navigator.mozL10n.DateTimeFormat();var timeFormat,dateFormat;var page=document.querySelector('#landing-page');var clockElemNumbers=document.querySelector('#landing-clock .numbers');var clockElemMeridiem=document.querySelector('#landing-clock .meridiem');var dateElem=document.querySelector('#landing-date');var updateInterval=null;var updateTimeout=null;page.addEventListener('gridpagehideend',function onPageHideEnd(){stopClock();});navigator.mozL10n.ready(function localize(){timeFormat=_('shortTimeFormat');dateFormat=_('longDateFormat');startClock();page.addEventListener('gridpageshowstart',startClock);});var clockOrigin=document.location.protocol+'//clock.'+
document.location.host.replace(/(^[\w\d]+\.)?([\w\d]+\.[a-z]+)/,'$2');var landingTime=document.querySelector('#landing-time');landingTime.addEventListener('click',function launchClock(evt){Applications.getByOrigin(clockOrigin).launch();});landingTime.addEventListener('contextmenu',function contextMenu(evt){evt.stopImmediatePropagation();});document.addEventListener('mozvisibilitychange',function mozVisChange(){document.mozHidden?stopClock():startClock();});function startClock(){var date=updateUI();if(updateTimeout==null){updateTimeout=window.setTimeout(function setUpdateInterval(){updateUI();if(updateInterval==null){updateInterval=window.setInterval(function updating(){updateUI();},60000);}},(60-date.getSeconds())*1000);}}
function stopClock(){if(updateTimeout!=null){window.clearTimeout(updateTimeout);updateTimeout=null;}
if(updateInterval!=null){window.clearInterval(updateInterval);updateInterval=null;}}
function updateUI(){var date=new Date();var time=dateTimeFormat.localeFormat(date,timeFormat);clockElemNumbers.textContent=time.match(/([012]?\d).[0-5]\d/g);clockElemMeridiem.textContent=(time.match(/AM|PM/i)||[]).join('');dateElem.textContent=dateTimeFormat.localeFormat(date,dateFormat);return date;}}());;'use strict';var ConfirmDialog=(function(){var dialog=document.getElementById('confirm-dialog');var titleElem=document.getElementById('confirm-dialog-title');var messageElem=document.getElementById('confirm-dialog-message');var cancelButton=document.getElementById('confirm-dialog-cancel-button');var confirmButton=document.getElementById('confirm-dialog-confirm-button');return{hide:function dialog_hide(){dialog.classList.remove('visible');},show:function dialog_show(title,msg,cancel,confirm){titleElem.textContent=title;messageElem.textContent=msg;cancelButton.textContent=cancel.title;confirmButton.textContent=confirm.title;cancelButton.className='';confirmButton.className='';if(cancel.applyClass){cancelButton.classList.add(cancel.applyClass);}
if(confirm.applyClass){confirmButton.classList.add(confirm.applyClass);}
cancelButton.onclick=confirmButton.onclick=clickHandler;function clickHandler(evt){evt.target===confirmButton?confirm.callback():cancel.callback();return false;}
dialog.classList.add('visible');}};}());;'use strict';var Bookmark=function Bookmark(params){this.removable=true;if('iconable'in params){this.iconable=params.iconable;}else{this.iconable=true;}
this.isBookmark=true;this.url=this.bookmarkURL=this.origin=params.bookmarkURL;this.manifest={name:params.name,icons:{60:params.icon},default_locale:'en-US'};this.useAsyncPanZoom='useAsyncPanZoom'in params&&params.useAsyncPanZoom;};Bookmark.prototype={launch:function bookmark_launch(){var features={name:this.manifest.name.replace(/\s/g,'&nbsp;'),icon:this.manifest.icons['60'],remote:true,useAsyncPanZoom:this.useAsyncPanZoom};window.open(this.url,'_blank',JSON.stringify(features));},uninstall:function bookmark_uninstall(){GridManager.uninstall(this);}};var BookmarkEditor={init:function bookmarkEditor_show(options){this.data=options.data;this.onsaved=options.onsaved;this.oncancelled=options.oncancelled;this.bookmarkEntrySheet=document.getElementById('bookmark-entry-sheet');this.bookmarkTitle=document.getElementById('bookmark-title');this.bookmarkUrl=document.getElementById('bookmark-url');this.cancelButton=document.getElementById('button-bookmark-cancel');this.addButton=document.getElementById('button-bookmark-add');this.cancelButton.addEventListener('click',this.close.bind(this));this.addButton.addEventListener('click',this.save.bind(this));this.bookmarkTitle.value=this.data.name||'';this.bookmarkUrl.value=this.data.url||'';this.origin=document.location.protocol+'//homescreen.'+
document.location.host.replace(/(^[\w\d]+.)?([\w\d]+.[a-z]+)/,'$2');},close:function bookmarkEditor_close(){this.oncancelled();},save:function bookmarkEditor_save(){if(/^https?:/.test(this.bookmarkUrl.value)==false)
return;this.data.name=this.bookmarkTitle.value;this.data.bookmarkURL=this.bookmarkUrl.value;var homeScreenWindow=window.open('','main');if(!homeScreenWindow)
this.close();else{homeScreenWindow.postMessage(new Message(Message.Type.ADD_BOOKMARK,this.data),this.origin);this.onsaved();}}};;'use strict';const HomeState=(function(){var DB_NAME='homescreen';var GRID_STORE_NAME='grid';var DB_VERSION=1;var database=null;var initQueue=[];function loadInitialState(iterator,success,error){var grid=Configurator.getSection('grid')||[];for(var i=0;i<grid.length;i++){grid[i]={index:i,icons:grid[i]};}
HomeState.saveGrid(grid,function onSaveGrid(){grid.forEach(iterator);success();},error);}
function openDB(success,error){try{var indexedDB=window.indexedDB||window.webkitIndexedDB||window.mozIndexedDB||window.msIndexedDB;}catch(e){error(e);return;}
if(!indexedDB){error('Indexed DB is not available!!!');return;}
var request;var emptyDB=false;try{request=indexedDB.open(DB_NAME,DB_VERSION);}catch(ex){error(ex.message);return;}
request.onsuccess=function(event){database=event.target.result;success(emptyDB);};request.onerror=function(event){error('Database error: '+event.target.errorCode);};request.onupgradeneeded=function(event){var db=event.target.result;if(event.oldVersion==0){emptyDB=true;db.createObjectStore(GRID_STORE_NAME,{keyPath:'index'});}};}
function newTxn(storeName,txn_type,callback,successCb,failureCb){if(!database){initQueue.push(newTxn.bind(null,storeName,txn_type,callback,successCb,failureCb));return;}
var txn=database.transaction([storeName],txn_type);var store=txn.objectStore(storeName);txn.oncomplete=function(event){if(successCb){successCb(event);}};txn.onerror=function(event){var target=event.target;console.warn('Caught error on transaction: '+target.error.name);if(failureCb){failureCb(target.errorCode);}};callback(txn,store);}
return{init:function st_init(iterator,success,error){openDB(function(emptyDB){if(emptyDB){loadInitialState(iterator,success,error);return;}
HomeState.getGrid(iterator,success,error);},error);},saveGrid:function st_saveGrid(pages,success,error){if(!database){if(error){error('Database is not available');}
return;}
newTxn(GRID_STORE_NAME,'readwrite',function(txn,store){store.clear();var len=pages.length;for(var i=0;i<len;i++){store.put(pages[i]);}
if(success){success();}});},getGrid:function st_getGrid(iterator,success,error){if(!database){if(error){error('Database is not available');}
return;}
newTxn(GRID_STORE_NAME,'readonly',function(txn,store){store.openCursor().onsuccess=function onsuccess(event){var cursor=event.target.result;if(!cursor)
return;iterator(cursor.value);cursor.continue();};},function(){success();},error);}};})();;'use strict';var IconRetriever=(function(){var requests;var pendingsRequests;function retrieve(request){var xhr=new XMLHttpRequest({mozAnon:true,mozSystem:true});var icon=request.icon.descriptor.icon;xhr.open('GET',icon,true);xhr.responseType='blob';try{xhr.send(null);}catch(evt){console.error('Got an exception when trying to load icon "'+icon+' +" falling back to cached icon. Exception is: '+evt.message);setTimeout(function(){postError(request);});return;}
xhr.onload=function onload(evt){var status=xhr.status;if(status!==0&&status!==200){console.error('Got HTTP status '+status+' trying to load icon '+
icon);postError(request,false);return;}
postSuccess(request,xhr.response);};xhr.ontimeout=xhr.onerror=function onerror(evt){console.error(evt.type,' while HTTP GET: ',icon);postError(request,true);};}
function postSuccess(request,response){var uid=request.uid;if(typeof requests[uid].success==='function'){requests[uid].success.call(request.icon,response);}
remove(request);}
function postError(request,retry){var uid=request.uid;if(typeof requests[uid].error==='function'){requests[uid].error.call(request.icon);}
if(retry){pendingsRequests[uid]=requests[uid];}else{remove(request);}}
function remove(request){var uid=request.uid;delete requests[uid];delete pendingsRequests[uid];}
function online(){for(var uid in pendingsRequests){retrieve(pendingsRequests[uid]);}}
var HTTP_PROTOCOL='http';function canBeDispatched(request){return(window.navigator.onLine||request.icon.descriptor.icon.slice(0,HTTP_PROTOCOL.length)!==HTTP_PROTOCOL);}
return{init:function IconRetriever_init(){requests=Object.create(null);pendingsRequests=Object.create(null);window.addEventListener('online',online);},get:function IconRetriever_get(request){var uid=request.uid=request.icon.getUID();var pendingRequest=requests[uid];if(pendingRequest&&pendingRequest.icon.descriptor.icon==request.icon.descriptor.icon){return;}
requests[uid]=request;if(canBeDispatched(request)){retrieve(request);}else{pendingsRequests[uid]=request;}}};}());;'use strict';function Icon(descriptor,app){this.descriptor=descriptor;this.app=app;this.updateAppStatus(app);}
Icon.prototype={MIN_ICON_SIZE:52,MAX_ICON_SIZE:60,DEFAULT_BOOKMARK_ICON_URL:window.location.protocol+'//'+
window.location.host+'/style/images/default_favicon.png',DEFAULT_ICON_URL:window.location.protocol+'//'+window.location.host+'/style/images/default.png',DOWNLOAD_ICON_URL:window.location.protocol+'//'+window.location.host+'/style/images/app_downloading.png',CANCELED_ICON_URL:window.location.protocol+'//'+window.location.host+'/style/images/app_paused.png',_descriptorIdentifiers:['manifestURL','entry_point','bookmarkURL','useAsyncPanZoom'],app:null,getUID:function icon_getUID(){var descriptor=this.descriptor;return(descriptor.manifestURL||descriptor.bookmarkURL)+
(descriptor.entry_point?descriptor.entry_point:'');},render:function icon_render(target){var container=this.container=document.createElement('li');container.className='icon';if(this.descriptor.hidden){delete this.descriptor.hidden;container.dataset.visible=false;}
var descriptor=this.descriptor;container.dataset.isIcon=true;this._descriptorIdentifiers.forEach(function(prop){var value=descriptor[prop];if(value)
container.dataset[prop]=value;});var localizedName=descriptor.localizedName||descriptor.name;container.setAttribute('role','button');container.setAttribute('aria-label',localizedName);var icon=this.icon=document.createElement('div');var img=this.img=new Image();img.setAttribute('role','presentation');img.width=64;img.height=64;img.style.visibility='hidden';if(descriptor.renderedIcon){this.displayRenderedIcon();}else{this.fetchImageData();}
icon.appendChild(img);var wrapper=document.createElement('span');wrapper.className='labelWrapper';var label=this.label=document.createElement('span');label.textContent=localizedName;wrapper.appendChild(label);this.applyOverflowTextMask();icon.appendChild(wrapper);container.appendChild(icon);if(descriptor.removable===true){this.appendOptions();}
target.appendChild(container);if(this.downloading){container.style.visibility='visible';icon.classList.add('loading');}},appendOptions:function icon_appendOptions(){var options=this.container.querySelector('.options');if(options){return;}
options=document.createElement('span');options.className='options';options.dataset.isIcon=true;this.container.appendChild(options);},removeOptions:function icon_removeOptions(){var options=this.container.querySelector('.options');if(!options){return;}
this.container.removeChild(options);},applyOverflowTextMask:function icon_applyOverflowTextMask(){var label=this.label;if(TextOverflowDetective.check(label.textContent)){label.parentNode.classList.add('mask');}else{label.parentNode.classList.remove('mask');}},fetchImageData:function icon_fetchImageData(){var descriptor=this.descriptor;var icon=descriptor.icon;if(!icon){this.loadCachedIcon();return;}
this.loadCachedIcon();IconRetriever.get({icon:this,success:function(blob){this.loadImageData(blob);},error:function(){if(this.icon&&!this.downloading&&this.icon.classList.contains('loading')){this.icon.classList.remove('loading');this.img.src=null;}
this.loadCachedIcon();}});},loadCachedIcon:function icon_loadCachedImage(){var oldRenderedIcon=this.descriptor.oldRenderedIcon;if(oldRenderedIcon&&oldRenderedIcon instanceof Blob){this.renderBlob(oldRenderedIcon);}else{this.loadDefaultIcon();}},loadImageData:function icon_loadImageData(blob){var self=this;var img=new Image();img.src=window.URL.createObjectURL(blob);if(this.icon&&!this.downloading){this.icon.classList.remove('loading');}
img.onload=function icon_loadSuccess(){img.onload=img.onerror=null;window.URL.revokeObjectURL(img.src);self.renderImage(img);};img.onerror=function icon_loadError(){console.error('error while loading the icon',img.src,'. Falling back '+'to default icon.');window.URL.revokeObjectURL(img.src);self.loadDefaultIcon(img);};},loadDefaultIcon:function icon_loadDefaultIcon(img){var image=img||new Image();var self=this;if(self.img&&self.img.src){image.onload=image.onerror=null;return;}
var blob=GridManager.getBlobByDefault(self.app);if(blob===null){image.src=getDefaultIcon(self.app);image.onload=function icon_defaultIconLoadSucess(){image.onload=image.onerror=null;self.renderImage(image);};}else{self.renderBlob(blob);image.onload=image.onerror=null;}},renderImageForBookMark:function icon_renderImageForBookmark(img){var self=this;var canvas=document.createElement('canvas');canvas.width=64;canvas.height=64;var ctx=canvas.getContext('2d');var background=new Image();background.src='style/images/default_background.png';background.onload=function icon_loadBackgroundSuccess(){ctx.shadowColor='rgba(0,0,0,0.8)';ctx.shadowBlur=2;ctx.shadowOffsetY=2;ctx.drawImage(background,2,2);ctx.shadowBlur=0;ctx.shadowOffsetY=0;ctx.mozImageSmoothingEnabled=false;ctx.drawImage(img,16,16,32,32);canvas.toBlob(self.renderBlob.bind(self));};},renderImage:function icon_renderImage(img){if(this.app&&this.app.iconable){this.renderImageForBookMark(img);return;}
var canvas=document.createElement('canvas');canvas.width=64;canvas.height=64;var ctx=canvas.getContext('2d');ctx.clearRect(0,0,canvas.width,canvas.height);ctx.shadowColor='rgba(0,0,0,0.8)';ctx.shadowBlur=2;ctx.shadowOffsetY=2;img.width=Math.min(this.MAX_ICON_SIZE,Math.max(img.width,this.MIN_ICON_SIZE));img.height=Math.min(this.MAX_ICON_SIZE,Math.max(img.height,this.MIN_ICON_SIZE));var width=Math.min(img.width,canvas.width-4);var height=Math.min(img.width,canvas.height-4);ctx.drawImage(img,(canvas.width-width)/2,(canvas.height-height)/2,width,height);ctx.fill();canvas.toBlob(this.renderBlob.bind(this));},renderBlob:function icon_renderBlob(blob){this.descriptor.renderedIcon=blob;GridManager.markDirtyState();this.displayRenderedIcon();},displayRenderedIcon:function icon_displayRenderedIcon(img,skipRevoke){img=img||this.img;var url=window.URL.createObjectURL(this.descriptor.renderedIcon);img.src=url;var self=this;img.onload=img.onerror=function cleanup(){img.style.visibility='visible';if(!skipRevoke)
window.URL.revokeObjectURL(url);if(self.needsShow)
self.show();};},show:function icon_show(){if(!this.img.naturalWidth){this.needsShow=true;return;}
this.needsShow=false;var container=this.container;container.dataset.visible=true;container.addEventListener('animationend',function animationEnd(e){container.removeEventListener('animationend',animationEnd);delete container.dataset.visible;});},updateAppStatus:function icon_updateAppStatus(app){if(app){this.downloading=app.downloading;this.cancelled=(app.installState==='pending')&&!app.downloading;}else{this.downloading=false;this.cancelled=false;}},update:function icon_update(descriptor,app){this.app=app;this.updateAppStatus(app);var oldDescriptor=this.descriptor;this.descriptor=descriptor;descriptor.removable===true?this.appendOptions():this.removeOptions();if(descriptor.updateTime==oldDescriptor.updateTime&&descriptor.icon==oldDescriptor.icon){this.descriptor.renderedIcon=oldDescriptor.renderedIcon;}else{this.descriptor.oldRenderedIcon=oldDescriptor.renderedIcon;this.fetchImageData();}
if(descriptor.updateTime!=oldDescriptor.updateTime||descriptor.name!=oldDescriptor.name||descriptor.localizedName!=oldDescriptor.localizedName){this.translate();}},showDownloading:function icon_showDownloading(){this.img.src=this.DOWNLOAD_ICON_URL;this.container.style.visibility='visible';this.icon.classList.add('loading');},showCancelled:function icon_showCancelled(){this.img.src=this.CANCELED_ICON_URL;this.container.style.visibility='visible';this.icon.classList.remove('loading');this.fetchImageData();},remove:function icon_remove(){this.container.parentNode.removeChild(this.container);},translate:function icon_translate(){var descriptor=this.descriptor;if(descriptor.bookmarkURL)
return;var app=this.app;if(!app)
return;var manifest=app.manifest||app.updateManifest;if(!manifest)
return;var iconsAndNameHolder=manifest;var entryPoint=descriptor.entry_point;if(entryPoint)
iconsAndNameHolder=manifest.entry_points[entryPoint];var localizedName=new ManifestHelper(iconsAndNameHolder).name;this.label.textContent=localizedName;if(descriptor.localizedName!=localizedName){descriptor.localizedName=localizedName;GridManager.markDirtyState();}
this.applyOverflowTextMask();},onDragStart:function icon_onDragStart(x,y){this.initX=x;this.initY=y;var draggableElem=this.draggableElem=document.createElement('div');draggableElem.className='draggable';var skipRevoke=true;this.displayRenderedIcon(this.img,skipRevoke);var icon=this.icon.cloneNode();var img=icon.querySelector('img');img.style.visibility='hidden';img.onload=img.onerror=function unhide(){img.style.visibility='visible';};draggableElem.appendChild(icon);var container=this.container;container.dataset.dragging='true';var rectangle=container.getBoundingClientRect();var style=draggableElem.style;style.left=rectangle.left+'px';style.top=rectangle.top+'px';this.initXCenter=(rectangle.left+rectangle.right)/2;this.initYCenter=(rectangle.top+rectangle.bottom)/2;this.initHeight=rectangle.bottom-rectangle.top;document.body.appendChild(draggableElem);},addClassToDragElement:function icon_addStyleToDragElement(className){this.draggableElem.classList.add(className);},removeClassToDragElement:function icon_addStyleToDragElement(className){this.draggableElem.classList.remove(className);},onDragMove:function icon_onDragMove(x,y){this.draggableElem.style.MozTransform='translate('+(x-this.initX)+'px,'+(y-this.initY)+'px)';},onDragStop:function icon_onDragStop(callback){var container=this.container;var rect=container.getBoundingClientRect();var x=(Math.abs(rect.left+rect.right)/2)%window.innerWidth;x-=this.initXCenter;var y=(rect.top+rect.bottom)/2+
(this.initHeight-(rect.bottom-rect.top))/2;y-=this.initYCenter;var draggableElem=this.draggableElem;var style=draggableElem.style;style.MozTransition='-moz-transform .4s';style.MozTransform='translate('+x+'px,'+y+'px)';draggableElem.querySelector('div').style.MozTransform='scale(1)';draggableElem.addEventListener('transitionend',function draggableEnd(e){draggableElem.removeEventListener('transitionend',draggableEnd);delete container.dataset.dragging;document.body.removeChild(draggableElem);var img=draggableElem.querySelector('img');window.URL.revokeObjectURL(img.src);callback();});},getTop:function icon_getTop(){return this.container.getBoundingClientRect().top;},getLeft:function icon_getLeft(){return this.container.getBoundingClientRect().left;}};function TemplateIcon(isBookmark){var descriptor={name:'templateIcon',hidden:true,renderedIcon:null};var app={};if(isBookmark){app.iconable=true;}
Icon.call(this,descriptor,app);}
TemplateIcon.prototype={__proto__:Icon.prototype,loadDefaultIcon:function ticon_loadDefaultIcon(){var image=new Image();var self=this;image.src=getDefaultIcon(self.app);image.onload=function icon_defaultIconLoadSucess(){image.onload=null;self.renderImage(image);};},renderBlob:function ticon_renderBlob(blob){this.descriptor.renderedIcon=blob;}};function Page(container,icons){this.container=this.movableContainer=container;if(icons)
this.render(icons);}
Page.prototype={render:function pg_render(icons){this.olist=document.createElement('ol');for(var i=0;i<icons.length;i++){this.appendIcon(icons[i]);}
this.container.appendChild(this.olist);},moveByWithEffect:function pg_moveByWithEffect(scrollX,duration){var container=this.movableContainer;var style=container.style;style.MozTransform='translateX('+scrollX+'px)';style.MozTransition='-moz-transform '+duration+'ms ease';},moveBy:function pg_moveBy(scrollX){var style=this.movableContainer.style;style.MozTransform='translateX('+scrollX+'px)';style.MozTransition='';},ready:true,setReady:function pg_setReady(value){this.ready=value;if(value&&this.onReArranged){this.onReArranged();}},drop:function pg_drop(originIcon,targetIcon){if(originIcon===targetIcon){return;}
this.setReady(false);if(originIcon&&targetIcon&&this.olist.children.length>1){this.animate(this.olist.children,originIcon.container,targetIcon.container);}else{setTimeout(this.setReady.bind(this,true));}},animate:function pg_anim(children,originNode,targetNode){var beforeNode=targetNode;var initialIndex=children.indexOf(originNode);var endIndex=children.indexOf(targetNode);if(initialIndex===-1||endIndex===-1){setTimeout(this.setReady.bind(this,true));return;}
var upward=initialIndex<endIndex;if(upward){beforeNode=targetNode.nextSibling;initialIndex++;}else{initialIndex=initialIndex+endIndex;endIndex=initialIndex-endIndex;initialIndex=initialIndex-endIndex;endIndex--;}
var slice=Array.prototype.slice;var animatedChildren=slice.call(children,initialIndex,endIndex+1);var self=this;this.setAnimation(animatedChildren,initialIndex,upward);var lastNode=animatedChildren[animatedChildren.length-1];lastNode.addEventListener('animationend',function animationEnd(e){animatedChildren.forEach(function(iconContainer){iconContainer.style.MozAnimationName='';});self.olist.insertBefore(originNode,beforeNode);var lastNode=e.target;lastNode.removeEventListener('animationend',animationEnd);self.setReady(true);});},setAnimation:function pg_setAnimation(elts,init,upward){elts.forEach(function(elt,i){i+=init;elt.style.MozAnimationName=upward?(i%4===0?'jumpPrevRow':'jumpPrevCell'):(i%4===3?'jumpNextRow':'jumpNextCell');});},tap:function pg_tap(elem){if(Homescreen.isInEditMode()){if(elem.classList.contains('options')){var icon=GridManager.getIcon(elem.parentNode.dataset);if(icon.app)
Homescreen.showAppDialog(icon.app);}}else if('isIcon'in elem.dataset){var icon=GridManager.getIcon(elem.dataset);if(!icon.app)
return;if(icon.descriptor.entry_point){icon.app.launch(icon.descriptor.entry_point);return;}
if(icon.cancelled){GridManager.showRestartDownloadDialog(icon);return;}
icon.app.launch();}},prependIcon:function pg_prependIcon(icon){this.setReady(false);var olist=this.olist;if(olist.children.length>0){olist.insertBefore(icon.container,olist.firstChild);}else{olist.appendChild(icon.container);}
this.setReady(true);},popIcon:function pg_popIcon(){var icon=this.getLastIcon();icon.remove();return icon;},insertBeforeLastIcon:function pg_insertBeforeLastIcon(icon){this.setReady(false);var olist=this.olist;if(olist.children.length>0){olist.insertBefore(icon.container,olist.lastChild);}
this.setReady(true);},getLastIcon:function pg_getLastIcon(){var lastIcon=this.olist.lastChild;if(!lastIcon)
return null;return GridManager.getIcon(lastIcon.dataset);},getFirstIcon:function pg_getFirstIcon(){var firstIcon=this.olist.firstChild;if(!firstIcon)
return null;return GridManager.getIcon(firstIcon.dataset);},appendIcon:function pg_appendIcon(icon){if(!icon.container){icon.render(this.olist,this.container);return;}
this.setReady(false);this.olist.appendChild(icon.container);this.setReady(true);},appendIconVisible:function pg_appendIconVisible(icon){if(this.getNumIcons()>=GridManager.pageHelper.maxIconsPerPage){this.insertBeforeLastIcon(icon);}else{this.appendIcon(icon);}},containsIcon:function pg_containsIcon(icon){return icon.container.parentNode===this.olist;},destroy:function pg_destroy(){this.container.parentNode.removeChild(this.container);},getNumIcons:function pg_getNumIcons(){return this.olist.children.length;},getIconDescriptors:function pg_getIconDescriptors(){var nodes=this.olist.children;return Array.prototype.map.call(nodes,function marshall(node){var icon=GridManager.getIcon(node.dataset);return icon.descriptor;});}};function getDefaultIcon(app){if(app&&app.iconable){return Icon.prototype.DEFAULT_BOOKMARK_ICON_URL;}else{return Icon.prototype.DEFAULT_ICON_URL;}}
function extend(subClass,superClass){var F=function(){};F.prototype=superClass.prototype;subClass.prototype=new F();subClass.prototype.constructor=subClass;subClass.uber=superClass.prototype;}
function Dock(container,icons){Page.call(this,container,icons);}
extend(Dock,Page);var dockProto=Dock.prototype;dockProto.baseRender=Page.prototype.render;dockProto.render=function dk_render(apps,target){this.baseRender(apps,target);this.movableContainer=this.olist;};dockProto.moveByWithEffect=function dk_moveByWithEffect(scrollX,duration){var container=this.movableContainer;var style=container.style;style.MozTransform='translateX('+scrollX+'px)';style.MozTransition='-moz-transform '+duration+'ms ease';};dockProto.moveByWithDuration=function dk_moveByWithDuration(scrollX,duration){var style=this.movableContainer.style;style.MozTransform='translateX('+scrollX+'px)';style.MozTransition='-moz-transform '+duration+'ms ease';};dockProto.setAnimation=function dk_setAnimation(elts,init,upward){var animation=upward?'jumpPrevCell':'jumpNextCell';elts.forEach(function(elt){elt.style.MozAnimationName=animation;});};dockProto.getLeft=function dk_getLeft(){return this.olist.getBoundingClientRect().left;};dockProto.getRight=function dk_getRight(){return this.getLeft()+this.getWidth();};dockProto.getWidth=function dk_getWidth(){return this.olist.clientWidth;};dockProto.getChildren=function dk_getChildren(){return this.olist.children;};HTMLCollection.prototype.indexOf=Array.prototype.indexOf;const TextOverflowDetective=(function(){var iconFakeWrapperWidth;var iconFakeLabel;function init(){var fakeIconName=document.querySelector('#fake-icon-name-wrapper');iconFakeWrapperWidth=fakeIconName.offsetWidth;iconFakeLabel=document.querySelector('#fake-icon-name');}
function check(text){if(!iconFakeLabel||!iconFakeWrapperWidth){init();}
iconFakeLabel.textContent=text;return iconFakeLabel.offsetWidth>=iconFakeWrapperWidth;}
return{check:check};})();;'use strict';const PaginationBar=(function(){var style,previousTotal,scroller;var dir=document.documentElement.dir==='rtl'?-100:100;return{init:function pb_init(element){scroller=(typeof element=='object')?element:document.querySelector(element);style=scroller.style;scroller.addEventListener('keypress',this);},show:function pb_show(){style.visibility='visible';},update:function pb_update(current,total){scroller.setAttribute('aria-valuenow',current);scroller.setAttribute('aria-valuemax',total-1);if(total&&previousTotal!==total){style.width=(100/total)+'%';scroller.getBoundingClientRect();previousTotal=total;}
style.MozTransform='translateX('+current*dir+'%)';},handleEvent:function pb_handleEvent(evt){if(evt.type!='keypress'||!evt.ctrlKey)
return;switch(evt.keyCode){case evt.DOM_VK_RIGHT:GridManager.goToNextPage();break;case evt.DOM_VK_LEFT:GridManager.goToPreviousPage();break;}}};}());;'use strict';const DockManager=(function(){var container,dock;var MAX_NUM_ICONS=7;var maxNumAppInViewPort=4,numAppsBeforeDrag,maxOffsetLeft;var windowWidth=window.innerWidth;var duration=300;var initialOffsetLeft,initialOffsetRight,numApps,cellWidth;var isPanning=false,startEvent,currentX,deltaX,tapThreshold;var isTouch='ontouchstart'in window;var touchstart=isTouch?'touchstart':'mousedown';var touchmove=isTouch?'touchmove':'mousemove';var touchend=isTouch?'touchend':'mouseup';var getX=(function getXWrapper(){return isTouch?function(e){return e.touches[0].pageX}:function(e){return e.pageX};})();function addActive(target){if('isIcon'in target.dataset){target.classList.add('active');removeActive=function _removeActive(){target.classList.remove('active');}}else{removeActive=function(){};}}
var removeActive=function(){};function handleEvent(evt){switch(evt.type){case touchstart:evt.stopPropagation();initialOffsetLeft=dock.getLeft();initialOffsetRight=dock.getRight();numApps=dock.getNumIcons();startEvent=isTouch?evt.touches[0]:evt;attachEvents();addActive(evt.target);break;case touchmove:deltaX=getX(evt)-startEvent.pageX;if(!isPanning){if(Math.abs(deltaX)<tapThreshold){return;}else{isPanning=true;document.body.dataset.transitioning='true';}}
if(numApps<=maxNumAppInViewPort){return;}
if(deltaX<0){if(initialOffsetRight===windowWidth){return;}
if(initialOffsetRight+deltaX<windowWidth){deltaX=windowWidth-initialOffsetRight;}}else{if(initialOffsetLeft===0){return;}
if(initialOffsetLeft+deltaX>0){deltaX=-initialOffsetLeft;}}
dock.moveBy(initialOffsetLeft+deltaX);break;case touchend:releaseEvents();if(!isPanning){dock.tap(evt.target);}else{isPanning=false;onTouchEnd(deltaX);}
removeActive();break;case'contextmenu':if(isPanning){evt.stopImmediatePropagation();return;}
if(GridManager.pageHelper.getCurrentPageNumber()>GridManager.landingPage){Homescreen.setMode('edit');removeActive();if('isIcon'in evt.target.dataset){DragDropManager.start(evt,{'x':startEvent.pageX,'y':startEvent.pageY});}}
break;}}
function goNextSet(){if(dock.getLeft()<=maxOffsetLeft){return;}
dock.moveByWithDuration(maxOffsetLeft,duration);}
function goPreviousSet(){if(dock.getLeft()>=0){return;}
dock.moveByWithDuration(0,duration);}
function onTouchEnd(scrollX){if(dock.getNumIcons()<=maxNumAppInViewPort||dock.getLeft()===0||dock.getRight()===windowWidth){delete document.body.dataset.transitioning;return;}
dock.moveByWithEffect(scrollX>0?0:maxOffsetLeft,duration);container.addEventListener('transitionend',function transEnd(e){container.removeEventListener('transitionend',transEnd);delete document.body.dataset.transitioning;});}
function releaseEvents(){container.removeEventListener('contextmenu',handleEvent);window.removeEventListener(touchmove,handleEvent);window.removeEventListener(touchend,handleEvent);}
function attachEvents(){container.addEventListener('contextmenu',handleEvent);window.addEventListener(touchmove,handleEvent);window.addEventListener(touchend,handleEvent);}
function placeAfterRemovingApp(numApps,centering){document.body.dataset.transitioning='true';if(centering||numApps<=maxNumAppInViewPort){dock.moveByWithDuration(maxOffsetLeft/2,.5);}else{dock.moveByWithDuration(dock.getLeft()+cellWidth,.5);}
container.addEventListener('transitionend',function transEnd(e){container.removeEventListener('transitionend',transEnd);delete document.body.dataset.transitioning;});}
function calculateDimentions(numIcons){if(numIcons<=maxNumAppInViewPort){container.classList.remove('scrollable');}else{container.classList.add('scrollable');}
cellWidth=dock.getWidth()/numIcons;maxOffsetLeft=windowWidth-numIcons*cellWidth;}
return{init:function dm_init(containerEl,page,pTapThreshold){tapThreshold=pTapThreshold;container=containerEl;container.addEventListener(touchstart,handleEvent);dock=this.page=page;var numIcons=dock.getNumIcons();if(numIcons>maxNumAppInViewPort){container.classList.add('scrollable');}
calculateDimentions(numIcons);if(numIcons<=maxNumAppInViewPort){dock.moveBy(maxOffsetLeft/2);}},onDragStop:function dm_onDragStop(){container.addEventListener(touchstart,handleEvent);var numApps=dock.getNumIcons();calculateDimentions(numApps);if(numApps===numAppsBeforeDrag||numApps>maxNumAppInViewPort&&(numApps<numAppsBeforeDrag&&dock.getRight()>=windowWidth||numApps>numAppsBeforeDrag&&dock.getLeft()<0)){return;}
placeAfterRemovingApp(numApps,numApps>numAppsBeforeDrag);},onDragStart:function dm_onDragStart(){releaseEvents();container.removeEventListener(touchstart,handleEvent);numAppsBeforeDrag=dock.getNumIcons();},page:null,afterRemovingApp:function dm_afterRemovingApp(){maxOffsetLeft=windowWidth-dock.getNumIcons()*cellWidth;var numApps=dock.getNumIcons();if(numApps>maxNumAppInViewPort&&dock.getRight()>=windowWidth){return;}
placeAfterRemovingApp(numApps);},isFull:function dm_isFull(){return dock.getNumIcons()===MAX_NUM_ICONS;},goNextSet:goNextSet,goPreviousSet:goPreviousSet};}());;'use strict';var GridManager=(function(){var MAX_ICONS_PER_PAGE=4*4;var PREFERRED_ICON_SIZE=60;var SAVE_STATE_TIMEOUT=100;var container;var windowWidth=window.innerWidth;var panningThreshold=window.innerWidth/4,tapThreshold;var dragging=false;var defaultAppIcon,defaultBookmarkIcon;var opacityOnAppGridPageMax=.7;var kPageTransitionDuration=300;var overlay,overlayStyle;var overlayTransition='opacity '+kPageTransitionDuration+'ms ease';var numberOfSpecialPages=0,landingPage,prevLandingPage,nextLandingPage;var pages=[];var currentPage=1;var saveStateTimeout=null;var limits={left:0,right:0};var startEvent,isPanning=false,deltaX,removePanHandler,dummy=function(){};var isTouch='ontouchstart'in window;var touchstart=isTouch?'touchstart':'mousedown';var touchmove=isTouch?'touchmove':'mousemove';var touchend=isTouch?'touchend':'mouseup';var getX=(function getXWrapper(){return isTouch?function(e){return e.touches[0].pageX;}:function(e){return e.pageX;};})();function addActive(target){if('isIcon'in target.dataset){target.classList.add('active');removeActive=function _removeActive(){target.classList.remove('active');removeActive=function(){};};}else{removeActive=function(){};}}
var removeActive=function(){};function handleEvent(evt){switch(evt.type){case touchstart:if(currentPage||numberOfSpecialPages===1)
evt.stopPropagation();touchStartTimestamp=evt.timeStamp;startEvent=isTouch?evt.touches[0]:evt;deltaX=0;attachEvents();removePanHandler=dummy;isPanning=false;addActive(evt.target);break;case touchmove:if(evt.preventPanning===true){return;}
var startX=startEvent.pageX;var currentX=getX(evt);deltaX=currentX-startX;if(deltaX===0)
return;document.body.dataset.transitioning='true';window.removeEventListener(touchmove,handleEvent);var current=pages[currentPage].container.style;var forward=deltaX<0;var refresh;if(currentPage===0){var next=pages[currentPage+1].container.style;refresh=function(e){if(deltaX<=0){next.MozTransform='translateX('+(windowWidth+deltaX)+'px)';current.MozTransform='translateX('+deltaX+'px)';}else{startX=currentX;}};}else if(currentPage===pages.length-1){var previous=pages[currentPage-1].container.style;refresh=function(e){if(deltaX>=0){previous.MozTransform='translateX('+(-windowWidth+deltaX)+'px)';current.MozTransform='translateX('+deltaX+'px)';}else{startX=currentX;}};}else{var previous=pages[currentPage-1].container.style;var next=pages[currentPage+1].container.style;refresh=function(e){if(deltaX>=0){previous.MozTransform='translateX('+(-windowWidth+deltaX)+'px)';if(forward){forward=false;next.MozTransform='translateX('+windowWidth+'px)';}}else{next.MozTransform='translateX('+(windowWidth+deltaX)+'px)';if(!forward){forward=true;previous.MozTransform='translateX(-'+windowWidth+'px)';}}
current.MozTransform='translateX('+deltaX+'px)';};}
window.mozRequestAnimationFrame(refresh);if(currentPage>nextLandingPage||Homescreen.isInEditMode()){var pan=function(e){currentX=getX(e);deltaX=currentX-startX;if(!isPanning&&Math.abs(deltaX)>=tapThreshold){isPanning=true;}
window.mozRequestAnimationFrame(refresh);};}else{var setOpacityToOverlay=dummy;if(currentPage===prevLandingPage){setOpacityToOverlay=function(){if(!forward)
return;var opacity=opacityOnAppGridPageMax-
(Math.abs(deltaX)/windowWidth)*opacityOnAppGridPageMax;overlayStyle.opacity=Math.round(opacity*10)/10;}}else if(currentPage===landingPage){setOpacityToOverlay=function(){var opacity=(Math.abs(deltaX)/windowWidth)*opacityOnAppGridPageMax;overlayStyle.opacity=Math.round(opacity*10)/10;}}else{setOpacityToOverlay=function(){if(forward)
return;var opacity=opacityOnAppGridPageMax-
(Math.abs(deltaX)/windowWidth)*opacityOnAppGridPageMax;overlayStyle.opacity=Math.round(opacity*10)/10;}}
var pan=function(e){currentX=getX(e);deltaX=currentX-startX;if(!isPanning&&Math.abs(deltaX)>=tapThreshold){isPanning=true;}
window.mozRequestAnimationFrame(function(){refresh();setOpacityToOverlay();});};}
var container=pages[currentPage].container;container.addEventListener(touchmove,pan,true);removePanHandler=function removePanHandler(e){touchEndTimestamp=e?e.timeStamp:Number.MAX_VALUE;window.removeEventListener(touchend,removePanHandler,true);container.removeEventListener(touchmove,pan,true);window.mozRequestAnimationFrame(function panTouchEnd(){onTouchEnd(deltaX,e);removeActive();});};window.addEventListener(touchend,removePanHandler,true);window.removeEventListener(touchend,handleEvent);break;case touchend:releaseEvents();pageHelper.getCurrent().tap(evt.target);removeActive();break;case'contextmenu':if(isPanning){evt.stopImmediatePropagation();return;}
if(currentPage>landingPage&&'isIcon'in evt.target.dataset){evt.stopImmediatePropagation();removePanHandler();Homescreen.setMode('edit');removeActive();DragDropManager.start(evt,{'x':startEvent.pageX,'y':startEvent.pageY});}
break;}}
function applyEffectOverlay(index){overlayStyle.MozTransition=overlayTransition;overlayStyle.opacity=index===landingPage?0:opacityOnAppGridPageMax;}
function onTouchEnd(deltaX,evt){var page=currentPage;if(Math.abs(deltaX)>panningThreshold||(Math.abs(deltaX)>tapThreshold&&touchEndTimestamp-touchStartTimestamp<kPageTransitionDuration)){var forward=dirCtrl.goesForward(deltaX);if(forward&&currentPage<pages.length-1){page=page+1;}else if(!forward&&page>0&&(page===landingPage||page>=nextLandingPage+1||(page===nextLandingPage&&!Homescreen.isInEditMode()))){page=page-1;}}else if(!isPanning&&evt){releaseEvents();pageHelper.getCurrent().tap(evt.target);}
goToPage(page);}
function attachEvents(){window.addEventListener(touchmove,handleEvent);window.addEventListener(touchend,handleEvent);}
function releaseEvents(){window.removeEventListener(touchmove,handleEvent);window.removeEventListener(touchend,handleEvent);}
function exitFromEditMode(){markDirtyState();goToPage(currentPage);}
function ensurePanning(){container.addEventListener(touchstart,handleEvent,true);}
function markDirtyState(){if(saveStateTimeout!=null){window.clearTimeout(saveStateTimeout);}
saveStateTimeout=window.setTimeout(function saveStateTrigger(){saveStateTimeout=null;pageHelper.saveAll();},SAVE_STATE_TIMEOUT);}
function togglePagesVisibility(start,end){for(var i=0;i<pages.length;i++){var pagediv=pages[i].container;if(i<start||i>end){pagediv.style.display='none';}else{pagediv.style.display='block';}}}
function goToPageCallback(index,fromPage,toPage,dispatchEvents,callback){delete document.body.dataset.transitioning;if(dispatchEvents){fromPage.container.dispatchEvent(new CustomEvent('gridpagehideend'));toPage.container.dispatchEvent(new CustomEvent('gridpageshowend'));}
overlayStyle.MozTransition='';if(index){var previous=pages[index-1].container.style;previous.MozTransition='';previous.MozTransform='translateX(-'+windowWidth+'px)';}
if(index<pages.length-1){var next=pages[index+1].container.style;next.MozTransition='';next.MozTransform='translateX('+windowWidth+'px)';}
var current=toPage.container.style;current.MozTransition='';current.MozTransform='translateX(0)';togglePagesVisibility(index-1,index+1);if(callback){setTimeout(callback,0);}}
var touchStartTimestamp=0;var touchEndTimestamp=0;var lastGoingPageTimestamp=0;function goToPage(index,callback){document.location.hash=(index===landingPage?'root':'');if(index<0||index>=pages.length)
return;var delay=touchEndTimestamp-lastGoingPageTimestamp||kPageTransitionDuration;lastGoingPageTimestamp+=delay;var duration=delay<kPageTransitionDuration?delay:kPageTransitionDuration;var previousPage=pages[currentPage];var newPage=pages[index];if(index>=currentPage){var forward=1;var start=currentPage;var end=index;}else{var forward=-1;var start=index;var end=currentPage;}
applyEffectOverlay(index);currentPage=index;updatePaginationBar();if(previousPage===newPage){var borderingPagesToBeTranslated=false;if(index>0&&pages[index-1].container.style.display==='block'){pages[index-1].moveByWithEffect(-windowWidth,duration);borderingPagesToBeTranslated=true;}
newPage.moveByWithEffect(0,duration);if(index<pages.length-1&&pages[index+1].container.style.display==='block'){pages[index+1].moveByWithEffect(windowWidth,duration);borderingPagesToBeTranslated=true;}
if(borderingPagesToBeTranslated){container.addEventListener('transitionend',function transitionEnd(e){container.removeEventListener('transitionend',transitionEnd);goToPageCallback(index,previousPage,newPage,false,callback);});}else{goToPageCallback(index,previousPage,newPage,false,callback);}
return;}
togglePagesVisibility(start,end);previousPage.container.dispatchEvent(new CustomEvent('gridpagehidestart'));newPage.container.dispatchEvent(new CustomEvent('gridpageshowstart'));previousPage.moveByWithEffect(-forward*windowWidth,duration);newPage.moveByWithEffect(0,duration);container.addEventListener('transitionend',function transitionEnd(e){container.removeEventListener('transitionend',transitionEnd);goToPageCallback(index,previousPage,newPage,true,callback);});}
function goToNextPage(callback){document.body.dataset.transitioning='true';goToPage(currentPage+1,callback);}
function goToPreviousPage(callback){document.body.dataset.transitioning='true';goToPage(currentPage-1,callback);}
function updatePaginationBar(){PaginationBar.update(currentPage,pages.length);}
var dirCtrl={};function setDirCtrl(){function goesLeft(x){return(x>0);}
function goesRight(x){return(x<0);}
function limitLeft(x){return(x<limits.left);}
function limitRight(x){return(x>limits.right);}
var rtl=(document.documentElement.dir=='rtl');dirCtrl.offsetPrev=rtl?-1:1;dirCtrl.offsetNext=rtl?1:-1;dirCtrl.limitPrev=rtl?limitRight:limitLeft;dirCtrl.limitNext=rtl?limitLeft:limitRight;dirCtrl.translatePrev=rtl?'translateX(100%)':'translateX(-100%)';dirCtrl.translateNext=rtl?'translateX(-100%)':'translateX(100%)';dirCtrl.goesForward=rtl?goesLeft:goesRight;}
var haveLocale=false;function localize(){setDirCtrl();for(var manifestURL in appIcons){var iconsForApp=appIcons[manifestURL];for(var entryPoint in iconsForApp){iconsForApp[entryPoint].translate();}}
for(var bookmarkURL in bookmarkIcons){bookmarkIcons[bookmarkURL].translate();}
haveLocale=true;}
function getFirstPageWithEmptySpace(){for(var i=numberOfSpecialPages;i<pages.length;i++){if(pages[i].getNumIcons()<MAX_ICONS_PER_PAGE){return i;}}
return pages.length;}
function removeEmptyPages(){var oldCurrentPage=currentPage;pages.forEach(function checkIsEmpty(page,index){if(index<numberOfSpecialPages){return;}
if(page.getNumIcons()===0){pageHelper.remove(index);if(currentPage>=index)
currentPage-=1;}});if(oldCurrentPage>currentPage)
goToPage(currentPage);}
function ensurePagesOverflow(){pages.forEach(function checkIsOverflow(page,index){if(index<numberOfSpecialPages){return;}
while(page.getNumIcons()>MAX_ICONS_PER_PAGE){var propagateIco=page.popIcon();if(index===pages.length-1){pageHelper.addPage([propagateIco]);}else{pages[index+1].prependIcon(propagateIco);}}});}
var pageHelper={maxIconsPerPage:MAX_ICONS_PER_PAGE,addPage:function(icons){var pageElement=document.createElement('div');var page=new Page(pageElement,icons);pages.push(page);pageElement.className='page';container.appendChild(pageElement);updatePaginationBar();},remove:function gm_remove(index){pages[index].destroy();pages.splice(index,1);updatePaginationBar();},saveAll:function(){var state=pages.slice(numberOfSpecialPages);state.unshift(DockManager.page);for(var i=0;i<state.length;i++){var page=state[i];state[i]={index:i,icons:page.getIconDescriptors()};}
HomeState.saveGrid(state);},getNext:function(){return pages[currentPage+1];},getPrevious:function(){return pages[currentPage-1];},getCurrent:function(){return pages[currentPage];},getLast:function(){return pages[pages.length-1];},getCurrentPageNumber:function(){return currentPage;},getTotalPagesNumber:function(){return pages.length;}};var bookmarkIcons;var appIcons;var appsByOrigin;var bookmarksByOrigin;function rememberIcon(icon){var descriptor=icon.descriptor;if(descriptor.bookmarkURL){bookmarkIcons[descriptor.bookmarkURL]=icon;return;}
var iconsForApp=appIcons[descriptor.manifestURL];if(!iconsForApp)
iconsForApp=appIcons[descriptor.manifestURL]=Object.create(null);iconsForApp[descriptor.entry_point||'']=icon;}
function forgetIcon(icon){var descriptor=icon.descriptor;if(descriptor.bookmarkURL){delete bookmarkIcons[descriptor.bookmarkURL];return;}
var iconsForApp=appIcons[descriptor.manifestURL];if(!iconsForApp)
return;delete iconsForApp[descriptor.entry_point||''];}
function getIcon(descriptor){if(descriptor.bookmarkURL)
return bookmarkIcons[descriptor.bookmarkURL];var iconsForApp=appIcons[descriptor.manifestURL];return iconsForApp&&iconsForApp[descriptor.entry_point||''];}
function getIconsForApp(app){return appIcons[app.manifestURL];}
function getIconForBookmark(bookmarkURL){return bookmarkIcons[bookmarkURL];}
function getApps(){var apps=[];for(var origin in appsByOrigin){apps.push(appsByOrigin[origin]);}
return apps;}
function getAppByOrigin(url){return appsByOrigin[url];}
function initUI(selector){overlay=document.querySelector('#landing-overlay');overlayStyle=overlay.style;container=document.querySelector(selector);container.addEventListener('contextmenu',handleEvent);ensurePanning();limits.left=container.offsetWidth*0.05;limits.right=container.offsetWidth*0.95;setDirCtrl();numberOfSpecialPages=container.children.length;landingPage=numberOfSpecialPages-1;prevLandingPage=landingPage-1;nextLandingPage=landingPage+1;for(var i=0;i<container.children.length;i++){var pageElement=container.children[i];var page=new Page(pageElement,null);pages.push(page);}}
function initApps(apps){var appMgr=navigator.mozApps.mgmt;appMgr.oninstall=function oninstall(event){GridManager.install(event.application);};appMgr.onuninstall=function onuninstall(event){GridManager.uninstall(event.application);};appMgr.getAll().onsuccess=function onsuccess(event){var iconsByManifestURL=Object.create(null);for(var manifestURL in appIcons){iconsByManifestURL[manifestURL]=appIcons[manifestURL];}
pageHelper.addPage([]);var apps=event.target.result;apps.forEach(function eachApp(app){delete iconsByManifestURL[app.manifestURL];processApp(app);});for(var origin in bookmarksByOrigin){appsByOrigin[origin]=bookmarksByOrigin[origin];}
bookmarksByOrigin=null;for(var manifestURL in iconsByManifestURL){var iconsForApp=iconsByManifestURL[manifestURL];for(var entryPoint in iconsForApp){var icon=iconsForApp[entryPoint];icon.remove();markDirtyState();}}
ensurePagesOverflow();removeEmptyPages();};}
function convertDescriptorsToIcons(pageState){var icons=pageState.icons;for(var i=0;i<icons.length;i++){var descriptor=icons[i];var app=null;if(descriptor.bookmarkURL){app=new Bookmark(descriptor);bookmarksByOrigin[app.origin]=app;}
var icon=icons[i]=new Icon(descriptor,app);rememberIcon(icon);}
return icons;}
function processApp(app,callback){if(HIDDEN_APPS.indexOf(app.manifestURL)!=-1)
return;appsByOrigin[app.origin]=app;var manifest=app.manifest?app.manifest:app.updateManifest;if(!manifest)
return;var entryPoints=manifest.entry_points;if(!entryPoints||manifest.type!='certified'){createOrUpdateIconForApp(app);return;}
for(var entryPoint in entryPoints){if(!entryPoints[entryPoint].icons)
continue;createOrUpdateIconForApp(app,entryPoint);}}
function createOrUpdateIconForApp(app,entryPoint){if(!app.isBookmark){app.ondownloadapplied=function ondownloadapplied(event){createOrUpdateIconForApp(event.application,entryPoint);app.ondownloadapplied=null;app.ondownloaderror=null;};app.ondownloaderror=function ondownloaderror(event){createOrUpdateIconForApp(app,entryPoint);};}
var manifest=app.manifest?app.manifest:app.updateManifest;var iconsAndNameHolder=manifest;if(entryPoint)
iconsAndNameHolder=manifest.entry_points[entryPoint];iconsAndNameHolder=new ManifestHelper(iconsAndNameHolder);var descriptor={bookmarkURL:app.bookmarkURL,manifestURL:app.manifestURL,entry_point:entryPoint,updateTime:app.updateTime,removable:app.removable,name:iconsAndNameHolder.name,icon:bestMatchingIcon(app,iconsAndNameHolder),useAsyncPanZoom:app.useAsyncPanZoom};if(haveLocale&&!app.isBookmark){descriptor.localizedName=iconsAndNameHolder.name;}
var existingIcon=getIcon(descriptor);if(existingIcon){existingIcon.update(descriptor,app);markDirtyState();return;}
var icon=new Icon(descriptor,app);rememberIcon(icon);var index=getFirstPageWithEmptySpace();if(index<pages.length){pages[index].appendIcon(icon);}else{pageHelper.addPage([icon]);}
markDirtyState();}
function showRestartDownloadDialog(icon){var app=icon.app;var _=navigator.mozL10n.get;var confirm={title:_('download'),callback:function onAccept(){app.download();app.ondownloaderror=function(evt){icon.showCancelled();icon.updateAppStatus(evt.application);};app.onprogress=function onProgress(evt){app.onprogress=null;icon.updateAppStatus(evt.application);};icon.showDownloading();ConfirmDialog.hide();},applyClass:'recommend'};var cancel={title:_('cancel'),callback:ConfirmDialog.hide};var localizedName=icon.descriptor.localizedName||icon.descriptor.name;ConfirmDialog.show(_('restart-download-title'),_('restart-download-body',{'name':localizedName}),cancel,confirm);return;}
function bestMatchingIcon(app,manifest){if(app.installState==='pending'){return app.downloading?Icon.prototype.DOWNLOAD_ICON_URL:Icon.prototype.CANCELED_ICON_URL;}
var icons=manifest.icons;if(!icons){return getDefaultIcon(app);}
var preferredSize=Number.MAX_VALUE;var max=0;for(var size in icons){size=parseInt(size,10);if(size>max)
max=size;if(size>=PREFERRED_ICON_SIZE&&size<preferredSize)
preferredSize=size;}
if(preferredSize===Number.MAX_VALUE)
preferredSize=max;var url=icons[preferredSize];if(!url){return getDefaultIcon(app);}
if(url.indexOf('data:')==0||url.indexOf('app://')==0||url.indexOf('http://')==0||url.indexOf('https://')==0)
return url;if(url.charAt(0)!='/'){console.warn('`'+manifest.name+'` app icon is invalid. '+'Manifest `icons` attribute should contain URLs -or- '+'absolute paths from the origin field.');return getDefaultIcon(app);}
if(app.origin.slice(-1)=='/')
return app.origin.slice(0,-1)+url;return app.origin+url;}
function calculateDefaultIcons(){defaultAppIcon=new TemplateIcon();defaultAppIcon.loadDefaultIcon();defaultBookmarkIcon=new TemplateIcon(true);defaultBookmarkIcon.loadDefaultIcon();}
return{init:function gm_init(gridSelector,dockSelector,pTapThreshold,callback)
{calculateDefaultIcons();pages=[];bookmarkIcons=Object.create(null);appIcons=Object.create(null);appsByOrigin=Object.create(null);bookmarksByOrigin=Object.create(null);initUI(gridSelector);tapThreshold=pTapThreshold;IconRetriever.init();HomeState.init(function eachPage(pageState){if(pageState.index==0){var dockContainer=document.querySelector(dockSelector);var dock=new Dock(dockContainer,convertDescriptorsToIcons(pageState));DockManager.init(dockContainer,dock,tapThreshold);return;}
pageHelper.addPage(convertDescriptorsToIcons(pageState));},function onState(){initApps();callback();},function onError(error){var dockContainer=document.querySelector(dockSelector);var dock=new Dock(dockContainer,[]);DockManager.init(dockContainer,dock,tapThreshold);initApps();callback();});},onDragStart:function gm_onDragSart(){releaseEvents();container.removeEventListener(touchstart,handleEvent,true);dragging=document.body.dataset.dragging=true;},onDragStop:function gm_onDragStop(){delete document.body.dataset.dragging;dragging=false;delete document.body.dataset.transitioning;ensurePanning();ensurePagesOverflow();removeEmptyPages();},install:function gm_install(app){processApp(app);},uninstall:function gm_uninstall(app){var updateDock=false;var dock=DockManager.page;delete appsByOrigin[app.origin];if(app.isBookmark){var icon=bookmarkIcons[app.bookmarkURL];updateDock=dock.containsIcon(icon);icon.remove();delete bookmarkIcons[app.bookmarkURL];}else{var iconsForApp=appIcons[app.manifestURL];if(!iconsForApp)
return;for(var entryPoint in iconsForApp){var icon=iconsForApp[entryPoint];updateDock=updateDock||dock.containsIcon(icon);icon.remove();}
delete appIcons[app.manifestURL];}
if(updateDock)
DockManager.afterRemovingApp();removeEmptyPages();markDirtyState();},markDirtyState:markDirtyState,getIcon:getIcon,getIconsForApp:getIconsForApp,getIconForBookmark:getIconForBookmark,getApps:getApps,getAppByOrigin:getAppByOrigin,goToPage:goToPage,goToPreviousPage:goToPreviousPage,goToNextPage:goToNextPage,localize:localize,dirCtrl:dirCtrl,pageHelper:pageHelper,get landingPage(){return landingPage;},getBlobByDefault:function(app){if(app&&app.iconable){return defaultBookmarkIcon.descriptor.renderedIcon;}else{return defaultAppIcon.descriptor.renderedIcon;}},showRestartDownloadDialog:showRestartDownloadDialog,exitFromEditMode:exitFromEditMode,ensurePanning:ensurePanning};})();;'use strict';const DragDropManager=(function(){var CHECK_LIMITS_DELAY=700;var REARRANGE_DELAY=50;var isDisabledDrop=false;var isDockDisabled=false;var isDisabledCheckingLimits=false;var disabledCheckingLimitsTimeout=null;var draggableIcon,previousOverlapIcon,overlapingTimeout,overlapElem,originElem;var pageHelper=GridManager.pageHelper;var dirCtrl,limitY,overlapingDock;var currentEvent={},startEvent={};function setDisabledCheckingLimits(value){isDisabledCheckingLimits=value;if(value){disabledCheckingLimitsTimeout=setTimeout(function dg_disabledCheckingLimitsTimeout(){isDisabledCheckingLimits=false;checkLimits();},CHECK_LIMITS_DELAY);}}
var isTouch='ontouchstart'in window;var touchmove=isTouch?'touchmove':'mousemove';var touchend=isTouch?'touchend':'mouseup';var getTouch=(function getTouchWrapper(){return isTouch?function(e){return e.touches[0]}:function(e){return e};})();var transitioning=false;function onNavigationEnd(){transitioning=false;}
function overDock(){if(isDockDisabled){if(!overlapingDock){draggableIcon.addClassToDragElement('overDock');overlapingDock=isDisabledDrop=true;}
return;}
if(!overlapingDock){draggableIcon.addClassToDragElement('overDock');DockManager.page.appendIcon(draggableIcon);drop(DockManager.page);previousOverlapIcon=overlapElem;}
if(dirCtrl.limitNext(currentEvent.x)){DockManager.goNextSet();}else if(dirCtrl.limitPrev(currentEvent.x)){DockManager.goPreviousSet();}
overlapingDock=true;}
function overIconGrid(){if(transitioning){isDisabledDrop=true;return;}
isDisabledDrop=false;var currentX=currentEvent.x;var curPageObj=pageHelper.getCurrent();if(overlapingDock){draggableIcon.removeClassToDragElement('overDock');overlapingDock=false;curPageObj.appendIconVisible(draggableIcon);}else if(!isDisabledCheckingLimits){if(dirCtrl.limitNext(currentX)){isDisabledDrop=true;if(pageHelper.getCurrentPageNumber()<pageHelper.getTotalPagesNumber()-1){pageHelper.getNext().appendIconVisible(draggableIcon);}else if(curPageObj.getNumIcons()>1){pageHelper.addPage([draggableIcon]);}
setDisabledCheckingLimits(true);if(pageHelper.getNext()){GridManager.goToNextPage(onNavigationEnd);transitioning=true;}}else if(pageHelper.getCurrentPageNumber()>GridManager.landingPage+1&&dirCtrl.limitPrev(currentX)){isDisabledDrop=true;pageHelper.getPrevious().appendIconVisible(draggableIcon);setDisabledCheckingLimits(true);transitioning=true;GridManager.goToPreviousPage(onNavigationEnd);}}}
function checkLimits(){if(currentEvent.y>=limitY){overDock(overlapElem);}else{overIconGrid();}}
function onStart(elem){overlapElem=elem;draggableIcon=GridManager.getIcon(elem.dataset);draggableIcon.onDragStart(startEvent.x,startEvent.y);if(overlapingDock){draggableIcon.addClassToDragElement('overDock');}else if(DockManager.isFull()){isDockDisabled=true;}}
function stop(callback){clearTimeout(disabledCheckingLimitsTimeout);isDisabledCheckingLimits=false;isDisabledDrop=false;transitioning=false;var page=getPage();if(page.ready){draggableIcon.onDragStop(callback);}else{page.onReArranged=function fn_ready(){delete page.onReArranged;draggableIcon.onDragStop(callback);};}}
function drop(page){var classList=overlapElem.classList;if(classList.contains('icon')){var overlapIcon=GridManager.getIcon(overlapElem.dataset);page.drop(draggableIcon,overlapIcon);}else if(classList.contains('dockWrapper')){var firstIcon=page.getFirstIcon();if(currentEvent.x<firstIcon.getLeft()){if(draggableIcon!==firstIcon){page.drop(draggableIcon,firstIcon);}}else{var lastIcon=page.getLastIcon();if(lastIcon&&draggableIcon!==lastIcon){page.drop(draggableIcon,lastIcon);}}}
previousOverlapIcon=undefined;}
function onMove(evt){var x=currentEvent.x=getTouch(evt).pageX;var y=currentEvent.y=getTouch(evt).pageY;draggableIcon.onDragMove(x,y);var page=getPage();if(!page.ready){return;}
var newOverlapElem=overlapElem;if(overlapElem.classList.contains('page')){newOverlapElem=document.elementFromPoint(x,y);}else{var rectObject=overlapElem.getBoundingClientRect();if(overlapElem.classList.contains('page')||x<rectObject.left||x>rectObject.right||y<rectObject.top||y>rectObject.bottom){newOverlapElem=document.elementFromPoint(x,y);}}
if(newOverlapElem){overlapElem=newOverlapElem;handleMove(page,x,y);}}
function handleMove(page,x,y){var classList=overlapElem.classList;if(!classList){clearTimeout(overlapingTimeout);return;}
checkLimits(overlapElem);if(isDisabledDrop){clearTimeout(overlapingTimeout);return;}
if(previousOverlapIcon!==overlapElem){clearTimeout(overlapingTimeout);if(classList.contains('page')){var lastIcon=page.getLastIcon();if(lastIcon&&y>lastIcon.getTop()&&draggableIcon!==lastIcon){page.drop(draggableIcon,lastIcon);}}else{overlapingTimeout=setTimeout(drop,REARRANGE_DELAY,page);}}
previousOverlapIcon=overlapElem;}
function onEnd(evt){if(evt.target!==originElem)
return;clearTimeout(overlapingTimeout);window.removeEventListener(touchmove,onMove);window.removeEventListener(touchend,onEnd);stop(function dg_stop(){DockManager.onDragStop();GridManager.onDragStop();});}
function getPage(){return overlapingDock?DockManager.page:pageHelper.getCurrent();}
return{init:function ddm_init(){dirCtrl=GridManager.dirCtrl;limitY=window.innerHeight-
document.querySelector('#footer').offsetHeight;},start:function ddm_start(evt,initCoords){window.addEventListener(touchmove,onMove);window.addEventListener(touchend,onEnd);GridManager.onDragStart();DockManager.onDragStart();startEvent=initCoords;isDockDisabled=false;overlapingDock=(initCoords.y>=limitY)?true:false;originElem=evt.target;onStart(originElem.classList.contains('options')?originElem.parentNode:originElem);}};}());;var EverythingME={displayed:false,pageHideBySwipe:false,init:function EverythingME_init(){var footerStyle=document.querySelector('#footer').style;footerStyle.MozTransition='-moz-transform .3s ease';var page=document.getElementById('evmePage');page.addEventListener('gridpageshowend',function onpageshow(){page.removeEventListener('gridpageshowend',onpageshow);document.querySelector('#loading-overlay > section').style.visibility='visible';EverythingME.displayed=true;footerStyle.MozTransform="translateY(75px)";page.addEventListener('gridpageshowend',function onpageshowafterload(){if(EverythingME.displayed)return;EverythingME.displayed=true;footerStyle.MozTransform="translateY(75px)";EvmeFacade.onShow();});EverythingME.load(function success(){EvmeFacade.onShow();var loadingOverlay=document.querySelector('#loading-overlay');loadingOverlay.style.opacity=0;setTimeout(function starting(){document.querySelector('#evmeContainer').style.opacity=1;loadingOverlay.parentNode.removeChild(loadingOverlay);},0);});});page.addEventListener('gridpagehideend',function onpagehide(){if(!EverythingME.displayed)return;EverythingME.displayed=false;footerStyle.MozTransform='translateY(0)';EvmeFacade.onHide();EverythingME.pageHideBySwipe=false;});page.addEventListener('gridpagehidestart',function onpagehidestart(){EverythingME.pageHideBySwipe=true;});page.addEventListener('contextmenu',function longPress(evt){evt.stopImmediatePropagation();});window.addEventListener('hashchange',function hasChange(evt){if(!EverythingME.displayed||document.location.hash==='#evme'){return;}
var captured=EvmeFacade.onHideStart(EverythingME.pageHideBySwipe?'pageSwipe':'homeButtonClick');if(captured){evt.stopImmediatePropagation();document.location.hash='#evme';}});},load:function EverythingME_load(success){var CB=!('ontouchstart'in window),js_files=['js/etmmanager.js','js/Core.js','config/config.js','config/shortcuts.js','js/developer/utils.1.3.js','js/helpers/Utils.js','js/Brain.js','modules/Apps/Apps.js','modules/BackgroundImage/BackgroundImage.js','modules/Banner/Banner.js','modules/Dialog/Dialog.js','modules/Location/Location.js','modules/Shortcuts/Shortcuts.js','modules/ShortcutsCustomize/ShortcutsCustomize.js','modules/Searchbar/Searchbar.js','modules/SearchHistory/SearchHistory.js','modules/Helper/Helper.js','modules/Tip/Tip.js','modules/ConnectionMessage/ConnectionMessage.js','modules/SmartFolder/SmartFolder.js','js/helpers/Storage.js','js/plugins/Scroll.js','js/external/uuid.js','js/api/apiv2.js','js/api/DoATAPI.js','js/helpers/EventHandler.js','js/helpers/Idle.js','js/plugins/Analytics.js','js/plugins/APIStatsEvents.js'];var css_files=['css/common.css','modules/Apps/Apps.css','modules/BackgroundImage/BackgroundImage.css','modules/Banner/Banner.css','modules/Dialog/Dialog.css','modules/Shortcuts/Shortcuts.css','modules/ShortcutsCustomize/ShortcutsCustomize.css','modules/Searchbar/Searchbar.css','modules/Helper/Helper.css','modules/Tip/Tip.css','modules/ConnectionMessage/ConnectionMessage.css','modules/SmartFolder/SmartFolder.css'];var head=document.head;var scriptLoadCount=0;var cssLoadCount=0;var progressLabel=document.querySelector('#loading-overlay span');var progressElement=document.querySelector('#loading-overlay progress');var total=js_files.length+css_files.length,counter=0;function updateProgress(){var value=Math.floor(((++counter)/total)*100);progressLabel.textContent=value+'%';progressElement.value=value;}
function onScriptLoad(event){updateProgress();event.target.removeEventListener('load',onScriptLoad);if(++scriptLoadCount==js_files.length){EverythingME.start(success);}else{loadScript(js_files[scriptLoadCount]);}}
function onCSSLoad(event){updateProgress();event.target.removeEventListener('load',onCSSLoad);if(++cssLoadCount===css_files.length){loadScript(js_files[scriptLoadCount]);}else{loadCSS(css_files[cssLoadCount]);}}
function loadCSS(file){var link=document.createElement('link');link.type='text/css';link.rel='stylesheet';link.href='everything.me/'+file+(CB?'?'+Date.now():'');link.addEventListener('load',onCSSLoad);setTimeout(function appendCSS(){head.appendChild(link);},0);}
function loadScript(file){var script=document.createElement('script');script.type='text/javascript';script.src='everything.me/'+file+(CB?'?'+Date.now():'');script.defer=true;script.addEventListener('load',onScriptLoad);setTimeout(function appendScript(){head.appendChild(script)},0);}
loadCSS(css_files[cssLoadCount]);},initEvme:function EverythingME_initEvme(success){Evme.init();EvmeFacade=Evme;success();},start:function EverythingME_start(success){if(document.readyState==='complete'){EverythingME.initEvme(success);}else{window.addEventListener('load',function onload(){window.removeEventListener('load',onload);EverythingME.initEvme(success);});}},destroy:function EverythingME_destroy(){var list=document.querySelectorAll('head > [href*="everything.me"]');for(var i=0;i<list.length;i++){var resource=list[i];resource.parentNode.removeChild(resource);}}};var EvmeFacade={onHideStart:function onHideStart(){return false;}};;'use strict';const Homescreen=(function(){var mode='normal';var origin=document.location.protocol+'//homescreen.'+
document.location.host.replace(/(^[\w\d]+.)?([\w\d]+.[a-z]+)/,'$2');var _=navigator.mozL10n.get;setLocale();navigator.mozL10n.ready(function localize(){setLocale();GridManager.localize();});var initialized=false,landingPage;PaginationBar.init('.paginationScroller');function initialize(lPage){if(initialized){return;}
initialized=true;landingPage=lPage;window.addEventListener('hashchange',function(){if(document.location.hash!='#root')
return;if(Homescreen.isInEditMode()){exitFromEditMode();}else{GridManager.goToPage(landingPage);}
GridManager.ensurePanning();});var tapThreshold=Configurator.getSection('tap_threshold');if(typeof(tapThreshold)==='undefined'){tapThreshold=10;}
GridManager.init('.apps','.dockWrapper',tapThreshold,function gm_init(){PaginationBar.show();if(document.location.hash==='#root'){GridManager.goToPage(landingPage);}
DragDropManager.init();Wallpaper.init();});}
function exitFromEditMode(){Homescreen.setMode('normal');ConfirmDialog.hide();GridManager.exitFromEditMode();}
document.addEventListener('mozvisibilitychange',function mozVisChange(){if(document.mozHidden&&Homescreen.isInEditMode()){exitFromEditMode();}
if(document.mozHidden==false){setTimeout(function forceRepaint(){var helper=document.getElementById('repaint-helper');helper.classList.toggle('displayed');});}});window.addEventListener('message',function hs_onMessage(event){if(event.origin===origin){var message=event.data;switch(message.type){case Message.Type.ADD_BOOKMARK:var app=new Bookmark(message.data);GridManager.install(app);break;}}});function setLocale(){document.documentElement.lang=navigator.mozL10n.language.code;document.documentElement.dir=navigator.mozL10n.language.direction;}
return{showAppDialog:function h_showAppDialog(app){var title,body;var cancel={title:_('cancel'),callback:ConfirmDialog.hide};var confirm={callback:function onAccept(){ConfirmDialog.hide();if(app.isBookmark){app.uninstall();}else{navigator.mozApps.mgmt.uninstall(app);}},applyClass:'danger'};var manifest=app.manifest||app.updateManifest;if(app.isBookmark){title=_('remove-title-2',{name:manifest.name});body=_('remove-body',{name:manifest.name});confirm.title=_('remove');}else{manifest=new ManifestHelper(manifest);title=_('delete-title',{name:manifest.name});body=_('delete-body',{name:manifest.name});confirm.title=_('delete');}
ConfirmDialog.show(title,body,cancel,confirm);},isInEditMode:function(){return mode==='edit';},init:initialize,setMode:function(newMode){mode=document.body.dataset.mode=newMode;}};})();;'use strict';const Configurator=(function(){var conf={};var dummyProvider={init:function(){},destroy:function(){}}
var xhr=new XMLHttpRequest();xhr.overrideMimeType('application/json');xhr.open('GET','js/init.json',true);xhr.send(null);xhr.onload=function _xhrOnLoad(evt){try{conf=JSON.parse(xhr.responseText);var searchPage=conf.search_page;if(searchPage){var provider=window[searchPage.provider]||dummyProvider;if(searchPage.enabled){provider.init();Homescreen.init(1);}else{startHomescreenByDefault();setTimeout(provider.destroy,0);}}}catch(e){conf={};console.error('Failed parsing homescreen configuration file: '+e);startHomescreenByDefault();}}
xhr.onerror=function _xhrOnError(evt){console.error('File not found: js/init.json');startHomescreenByDefault();}
function startHomescreenByDefault(){var searchPage=document.querySelector('div[role="search-page"]');searchPage.parentNode.removeChild(searchPage);Homescreen.init(0);}
return{getSection:function(section){return conf[section];}}}());;'use strict';const Wallpaper=(function(){var overlay=document.getElementById('icongrid');function onHomescreenContextmenu(){var a=new MozActivity({name:'pick',data:{type:'image/jpeg',width:320,height:480}});a.onsuccess=function onWallpaperSuccess(){if(!a.result.blob)
return;var reader=new FileReader();reader.readAsDataURL(a.result.blob);reader.onload=function(){navigator.mozSettings.createLock().set({'wallpaper.image':reader.result});}};a.onerror=function onWallpaperError(){console.warn('pick failed!');};}
return{init:function init(){overlay.addEventListener('contextmenu',onHomescreenContextmenu);}};})();;var HIDDEN_APPS=["app://keyboard.gaiamobile.org/manifest.webapp","app://wallpaper.gaiamobile.org/manifest.webapp","app://bluetooth.gaiamobile.org/manifest.webapp","app://pdfjs.gaiamobile.org/manifest.webapp","app://homescreen.gaiamobile.org/manifest.webapp","app://system.gaiamobile.org/manifest.webapp"]